Index: vl.c
===================================================================
--- vl.c	(revision 4734)
+++ vl.c	(working copy)
@@ -7533,7 +7663,7 @@
 }
 
 #ifdef HAS_AUDIO
-struct soundhw soundhw[] = {
+static struct soundhw soundhw[] = {
 #ifdef HAS_AUDIO_CHOICE
 #if defined(TARGET_I386) || defined(TARGET_MIPS)
     {
@@ -7601,58 +7731,43 @@
 static void select_soundhw (const char *optarg)
 {
     struct soundhw *c;
-
+    QEMUDeviceClass *dc, *audio_class;
+    QEMUDevice *dev;
+    
     if (*optarg == '?') {
     show_valid_cards:
-
         printf ("Valid sound card names (comma separated):\n");
         for (c = soundhw; c->name; ++c) {
             printf ("%-11s %s\n", c->name, c->descr);
         }
-        printf ("\n-soundhw all will enable all of the above\n");
         exit (*optarg != '?');
-    }
-    else {
-        size_t l;
+    } else {
         const char *p;
-        char *e;
-        int bad_card = 0;
-
-        if (!strcmp (optarg, "all")) {
-            for (c = soundhw; c->name; ++c) {
-                c->enabled = 1;
-            }
-            return;
-        }
-
+        const char *e;
+        char class_name[64];
+        int l;
+        audio_class = qemu_class_find("audio-device");
+        
         p = optarg;
         while (*p) {
             e = strchr (p, ',');
             l = !e ? strlen (p) : (size_t) (e - p);
-
-            for (c = soundhw; c->name; ++c) {
-                if (!strncmp (c->name, p, l)) {
-                    c->enabled = 1;
-                    break;
-                }
+            if (l > sizeof(class_name) - 1)
+                l = sizeof(class_name) - 1;
+            memcpy(class_name, p, l);
+            class_name[l] = '\0';
+            
+            dc = qemu_class_find(class_name);
+            if (!dc || !qemu_class_instanceof(dc, audio_class)) {
+                fprintf(stderr, "Unknown audio device: '%s'\n", class_name);
+                goto show_valid_cards;
             }
-
-            if (!c->name) {
-                if (l > 80) {
-                    fprintf (stderr,
-                             "Unknown sound card name (too big to show)\n");
-                }
-                else {
-                    fprintf (stderr, "Unknown sound card name `%.*s'\n",
-                             (int) l, p);
-                }
-                bad_card = 1;
-            }
-            p += l + (e != NULL);
+            dev = qemu_device_new_nodup(dc, "audio");
+            if (!e)
+                break;
+            else 
+                p = e + 1;
         }
-
-        if (bad_card)
-            goto show_valid_cards;
     }
 }
 #endif
